ghc-8.2.2: The GHC API

Safe Haskell | None
Language | Haskell2010

TcGenFunctor

# Documentation

data FFoldType a #

Constructors

FT |

Fields

- ft_triv :: a

  Does not contain variable

- ft_var :: a

  The variable itself

- ft_co_var :: a

  The variable itself, contravariantly

- ft_fun :: a -> a -> a

  Function type

- ft_tup :: TyCon -> [a] -> a

  Tuple type

- ft_ty_app :: Type -> a -> a

  Type app, variable only in last argument

- ft_bad_app :: a

  Type app, variable other than in last argument

- ft_forall :: TcTyVar -> a -> a

  Forall type

functorLikeTraverse #

Arguments

:: TyVar | Variable to look for
-> FFoldType a | How to fold
-> Type | Type to process
-> a |

deepSubtypesContaining :: TyVar -> Type -> [TcType] #

foldDataConArgs :: FFoldType a -> DataCon -> [a] #

gen_Functor_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, BagDerivStuff) #

gen_Foldable_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, BagDerivStuff) #

gen_Traversable_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, BagDerivStuff) #